#
# Copyright PrimeRevenue, Inc. 2012
# All rights reserved.
#

Tent.TIMEZONES = [
		{
			 name:		"Australian Central Daylight Time"
			 abbr:		"ACDT"
			 UTCOffset:	"GMT+1030"
		},
		{
			 name:		"Australian Central Standard Time"
			 abbr:		"ACST"
			 UTCOffset:	"GMT+0930"
		},
		{
			 name:		"ASEAN Common Time"
			 abbr:		"ACT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Atlantic Daylight Time"
			 abbr:		"ADT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Australian Eastern Daylight Time"
			 abbr:		"AEDT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Australian Eastern Standard Time"
			 abbr:		"AEST"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Afghanistan Time"
			 abbr:		"AFT"
			 UTCOffset:	"GMT+0430"
		},
		{
			 name:		"Alaska Daylight Time"
			 abbr:		"AKDT"
			 UTCOffset:	"GMT-0800"
		},
		{
			 name:		"Alaska Standard Time"
			 abbr:		"AKST"
			 UTCOffset:	"GMT-0900"
		},
		{
			 name:		"Armenia Summer Time"
			 abbr:		"AMST"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Armenia Time"
			 abbr:		"AMT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Argentina Time"
			 abbr:		"ART"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Arab Standard Time (Kuwait, Riyadh)"
			 abbr:		"AST"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Arabian Standard Time (Abu Dhabi, Muscat)"
			 abbr:		"AST"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Arabic Standard Time (Baghdad)"
			 abbr:		"AST"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Atlantic Standard Time"
			 abbr:		"AST"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Australian Western Daylight Time"
			 abbr:		"AWDT"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Australian Western Standard Time"
			 abbr:		"AWST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Azores Standard Time"
			 abbr:		"AZOST"
			 UTCOffset:	"GMT-0100"
		},
		{
			 name:		"Azerbaijan Time"
			 abbr:		"AZT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Brunei Time"
			 abbr:		"BDT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"British Indian Ocean Time"
			 abbr:		"BIOT"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"Baker Island Time"
			 abbr:		"BIT"
			 UTCOffset:	"GMT-1200"
		},
		{
			 name:		"Bolivia Time"
			 abbr:		"BOT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Brasilia Time"
			 abbr:		"BRT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Bangladesh Standard Time"
			 abbr:		"BST"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"British Summer Time (British Standard Time from Feb 1968 to Oct 1971)"
			 abbr:		"BST"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Bhutan Time"
			 abbr:		"BTT"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"Central Africa Time"
			 abbr:		"CAT"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Cocos Islands Time"
			 abbr:		"CCT"
			 UTCOffset:	"GMT+0630"
		},
		{
			 name:		"Central Daylight Time (North America)"
			 abbr:		"CDT"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Cuba Daylight Time[1]"
			 abbr:		"CDT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Central European Daylight Time"
			 abbr:		"CEDT"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Central European Summer Time (Cf. HAEC)"
			 abbr:		"CEST"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Central European Time"
			 abbr:		"CET"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Chatham Daylight Time"
			 abbr:		"CHADT"
			 UTCOffset:	"GMT+1345"
		},
		{
			 name:		"Chatham Standard Time"
			 abbr:		"CHAST"
			 UTCOffset:	"GMT+1245"
		},
		{
			 name:		"Choibalsan"
			 abbr:		"CHOT"
			 UTCOffset:	"GMT-0800"
		},
		{
			 name:		"Chamorro Standard Time"
			 abbr:		"ChST"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Chuuk Time"
			 abbr:		"CHUT"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Clipperton Island Standard Time"
			 abbr:		"CIST"
			 UTCOffset:	"GMT-0800"
		},
		{
			 name:		"Central Indonesia Time"
			 abbr:		"CIT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Cook Island Time"
			 abbr:		"CKT"
			 UTCOffset:	"GMT-1000"
		},
		{
			 name:		"Chile Summer Time"
			 abbr:		"CLST"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Chile Standard Time"
			 abbr:		"CLT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Colombia Summer Time"
			 abbr:		"COST"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Colombia Time"
			 abbr:		"COT"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Central Standard Time (North America)"
			 abbr:		"CST"
			 UTCOffset:	"GMT-0600"
		},
		{
			 name:		"China Standard Time"
			 abbr:		"CST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Central Standard Time (Australia)"
			 abbr:		"CST"
			 UTCOffset:	"GMT+0930"
		},
		{
			 name:		"Central Summer Time (Australia)"
			 abbr:		"CST"
			 UTCOffset:	"GMT+1030"
		},
		{
			 name:		"Cuba Standard Time"
			 abbr:		"CST"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"China time"
			 abbr:		"CT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Cape Verde Time"
			 abbr:		"CVT"
			 UTCOffset:	"GMT-0100"
		},
		{
			 name:		"Central Western Standard Time (Australia)"
			 abbr:		"CWST"
			 UTCOffset:	"GMT+0845"
		},
		{
			 name:		"Christmas Island Time"
			 abbr:		"CXT"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Davis Time"
			 abbr:		"DAVT"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Dumont d'Urville Time"
			 abbr:		"DDUT"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"AIX specific equivalent of Central European Time[2]"
			 abbr:		"DFT"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Easter Island Standard Summer Time"
			 abbr:		"EASST"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Easter Island Standard Time"
			 abbr:		"EAST"
			 UTCOffset:	"GMT-0600"
		},
		{
			 name:		"East Africa Time"
			 abbr:		"EAT"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Eastern Caribbean Time (does not recognise DST)"
			 abbr:		"ECT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Ecuador Time"
			 abbr:		"ECT"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Eastern Daylight Time (North America)"
			 abbr:		"EDT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Eastern European Daylight Time"
			 abbr:		"EEDT"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Eastern European Summer Time"
			 abbr:		"EEST"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Eastern European Time"
			 abbr:		"EET"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Eastern Greenland Summer Time"
			 abbr:		"EGST"
			 UTCOffset:	"GMT+0000"
		},
		{
			 name:		"Eastern Greenland Time"
			 abbr:		"EGT"
			 UTCOffset:	"GMT-0100"
		},
		{
			 name:		"Eastern Indonesian Time"
			 abbr:		"EIT"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Eastern Standard Time (North America)"
			 abbr:		"EST"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Eastern Standard Time (Australia)"
			 abbr:		"EST"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Further-eastern_European_Time"
			 abbr:		"FET"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Fiji Time"
			 abbr:		"FJT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Falkland Islands Summer Time"
			 abbr:		"FKST"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Falkland Islands Time"
			 abbr:		"FKT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Fernando de Noronha Time"
			 abbr:		"FNT"
			 UTCOffset:	"GMT-0200"
		},
		{
			 name:		"Galapagos Time"
			 abbr:		"GALT"
			 UTCOffset:	"GMT-0600"
		},
		{
			 name:		"Gambier Islands"
			 abbr:		"GAMT"
			 UTCOffset:	"GMT-0900"
		},
		{
			 name:		"Georgia Standard Time"
			 abbr:		"GET"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"French Guiana Time"
			 abbr:		"GFT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Gilbert Island Time"
			 abbr:		"GILT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Gambier Island Time"
			 abbr:		"GIT"
			 UTCOffset:	"GMT-0900"
		},
		{
			 name:		"Greenwich Mean Time"
			 abbr:		"GMT"
			 UTCOffset:	"GMT+0000"
		},
		{
			 name:		"South Georgia and the South Sandwich Islands"
			 abbr:		"GST"
			 UTCOffset:	"GMT-0200"
		},
		{
			 name:		"Gulf Standard Time"
			 abbr:		"GST"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Guyana Time"
			 abbr:		"GYT"
			 UTCOffset:	"GMT-0400"
		},
		{
			 name:		"Hawaii-Aleutian Daylight Time"
			 abbr:		"HADT"
			 UTCOffset:	"GMT-0900"
		},
		{
			 name:		"Heure Avancée d'Europe Centrale francised name for CEST"
			 abbr:		"HAEC"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Hawaii-Aleutian Standard Time"
			 abbr:		"HAST"
			 UTCOffset:	"GMT-1000"
		},
		{
			 name:		"Hong Kong Time"
			 abbr:		"HKT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Heard and McDonald Islands Time"
			 abbr:		"HMT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Khovd Time"
			 abbr:		"HOVT"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Hawaii Standard Time"
			 abbr:		"HST"
			 UTCOffset:	"GMT-1000"
		},
		{
			 name:		"Indochina Time"
			 abbr:		"ICT"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Israel Daylight Time"
			 abbr:		"IDT"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Indian Ocean Time"
			 abbr:		"IOT"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Iran Daylight Time"
			 abbr:		"IRDT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Irkutsk Time"
			 abbr:		"IRKT"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Iran Standard Time"
			 abbr:		"IRST"
			 UTCOffset:	"GMT+0330"
		},
		{
			 name:		"Indian Standard Time"
			 abbr:		"IST"
			 UTCOffset:	"GMT+0530"
		},
		{
			 name:		"Irish Standard Time[3]"
			 abbr:		"IST"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Israel Standard Time"
			 abbr:		"IST"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Japan Standard Time"
			 abbr:		"JST"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Kyrgyzstan time"
			 abbr:		"KGT"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"Kosrae Time"
			 abbr:		"KOST"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Krasnoyarsk Time"
			 abbr:		"KRAT"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Korea Standard Time"
			 abbr:		"KST"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Lord Howe Standard Time"
			 abbr:		"LHST"
			 UTCOffset:	"GMT+1030"
		},
		{
			 name:		"Lord Howe Summer Time"
			 abbr:		"LHST"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Line Islands Time"
			 abbr:		"LINT"
			 UTCOffset:	"GMT+1400"
		},
		{
			 name:		"Magadan Time"
			 abbr:		"MAGT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Marquesas Islands Time"
			 abbr:		"MART"
			 UTCOffset:	"GMT-0930"
		},
		{
			 name:		"Mawson Station Time"
			 abbr:		"MAWT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Mountain Daylight Time (North America)"
			 abbr:		"MDT"
			 UTCOffset:	"GMT-0600"
		},
		{
			 name:		"Middle European Time Same zone as CET"
			 abbr:		"MET"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Middle European Saving Time Same zone as CEST"
			 abbr:		"MEST"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Marshall Islands"
			 abbr:		"MHT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Macquarie Island Station Time"
			 abbr:		"MIST"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Marquesas Islands Time"
			 abbr:		"MIT"
			 UTCOffset:	"GMT-0930"
		},
		{
			 name:		"Myanmar Time"
			 abbr:		"MMT"
			 UTCOffset:	"GMT+0630"
		},
		{
			 name:		"Moscow Time"
			 abbr:		"MSK"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Malaysia Standard Time"
			 abbr:		"MST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Mountain Standard Time (North America)"
			 abbr:		"MST"
			 UTCOffset:	"GMT-0700"
		},
		{
			 name:		"Myanmar Standard Time"
			 abbr:		"MST"
			 UTCOffset:	"GMT+0630"
		},
		{
			 name:		"Mauritius Time"
			 abbr:		"MUT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Maldives Time"
			 abbr:		"MVT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Malaysia Time"
			 abbr:		"MYT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"New Caledonia Time"
			 abbr:		"NCT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Newfoundland Daylight Time"
			 abbr:		"NDT"
			 UTCOffset:	"GMT-0230"
		},
		{
			 name:		"Norfolk Time"
			 abbr:		"NFT"
			 UTCOffset:	"GMT+1130"
		},
		{
			 name:		"Nepal Time"
			 abbr:		"NPT"
			 UTCOffset:	"GMT+0545"
		},
		{
			 name:		"Newfoundland Standard Time"
			 abbr:		"NST"
			 UTCOffset:	"GMT-0330"
		},
		{
			 name:		"Newfoundland Time"
			 abbr:		"NT"
			 UTCOffset:	"GMT-0330"
		},
		{
			 name:		"Niue Time"
			 abbr:		"NUT"
			 UTCOffset:	"GMT-1130"
		},
		{
			 name:		"New Zealand Daylight Time"
			 abbr:		"NZDT"
			 UTCOffset:	"GMT+1300"
		},
		{
			 name:		"New Zealand Standard Time"
			 abbr:		"NZST"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Omsk Time"
			 abbr:		"OMST"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"Oral Time"
			 abbr:		"ORAT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Pacific Daylight Time (North America)"
			 abbr:		"PDT"
			 UTCOffset:	"GMT-0700"
		},
		{
			 name:		"Peru Time"
			 abbr:		"PET"
			 UTCOffset:	"GMT-0500"
		},
		{
			 name:		"Kamchatka Time"
			 abbr:		"PETT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Papua New Guinea Time"
			 abbr:		"PGT"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Phoenix Island Time"
			 abbr:		"PHOT"
			 UTCOffset:	"GMT+1300"
		},
		{
			 name:		"Philippine Time"
			 abbr:		"PHT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Pakistan Standard Time"
			 abbr:		"PKT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Saint Pierre and Miquelon Daylight time"
			 abbr:		"PMDT"
			 UTCOffset:	"GMT-0200"
		},
		{
			 name:		"Saint Pierre and Miquelon Standard Time"
			 abbr:		"PMST"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Pohnpei Standard Time"
			 abbr:		"PONT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Pacific Standard Time (North America)"
			 abbr:		"PST"
			 UTCOffset:	"GMT-0800"
		},
		{
			 name:		"Philippine Standard Time"
			 abbr:		"PST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Réunion Time"
			 abbr:		"RET"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Rothera Research Station Time"
			 abbr:		"ROTT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Sakhalin Island time"
			 abbr:		"SAKT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Samara Time"
			 abbr:		"SAMT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"South African Standard Time"
			 abbr:		"SAST"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"Solomon Islands Time"
			 abbr:		"SBT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Seychelles Time"
			 abbr:		"SCT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Singapore Time"
			 abbr:		"SGT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Sri Lanka Time"
			 abbr:		"SLT"
			 UTCOffset:	"GMT+0530"
		},
		{
			 name:		"Suriname Time"
			 abbr:		"SRT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Samoa Standard Time"
			 abbr:		"SST"
			 UTCOffset:	"GMT-1100"
		},
		{
			 name:		"Singapore Standard Time"
			 abbr:		"SST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Showa Station Time"
			 abbr:		"SYOT"
			 UTCOffset:	"GMT+0300"
		},
		{
			 name:		"Tahiti Time"
			 abbr:		"TAHT"
			 UTCOffset:	"GMT-1000"
		},
		{
			 name:		"Thailand Standard Time"
			 abbr:		"THA"
			 UTCOffset:	"GMT+0700"
		},
		{
			 name:		"Indian/Kerguelen"
			 abbr:		"TFT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Tajikistan Time"
			 abbr:		"TJT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Tokelau Time"
			 abbr:		"TKT"
			 UTCOffset:	"GMT+1400"
		},
		{
			 name:		"Timor Leste Time"
			 abbr:		"TLT"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Turkmenistan Time"
			 abbr:		"TMT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Tonga Time"
			 abbr:		"TOT"
			 UTCOffset:	"GMT+1300"
		},
		{
			 name:		"Tuvalu Time"
			 abbr:		"TVT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"Coordinated Universal Time"
			 abbr:		"UCT"
			 UTCOffset:	"GMT+0000"
		},
		{
			 name:		"Ulaanbaatar Time"
			 abbr:		"ULAT"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Coordinated Universal Time"
			 abbr:		"GMT"
			 UTCOffset:	"GMT+0000"
		},
		{
			 name:		"Uruguay Summer Time"
			 abbr:		"UYST"
			 UTCOffset:	"GMT-0200"
		},
		{
			 name:		"Uruguay Standard Time"
			 abbr:		"UYT"
			 UTCOffset:	"GMT-0300"
		},
		{
			 name:		"Uzbekistan Time"
			 abbr:		"UZT"
			 UTCOffset:	"GMT+0500"
		},
		{
			 name:		"Venezuelan Standard Time"
			 abbr:		"VET"
			 UTCOffset:	"GMT-0430"
		},
		{
			 name:		"Vladivostok Time"
			 abbr:		"VLAT"
			 UTCOffset:	"GMT+1000"
		},
		{
			 name:		"Volgograd Time"
			 abbr:		"VOLT"
			 UTCOffset:	"GMT+0400"
		},
		{
			 name:		"Vostok Station Time"
			 abbr:		"VOST"
			 UTCOffset:	"GMT+0600"
		},
		{
			 name:		"Vanuatu Time"
			 abbr:		"VUT"
			 UTCOffset:	"GMT+1100"
		},
		{
			 name:		"Wake Island Time"
			 abbr:		"WAKT"
			 UTCOffset:	"GMT+1200"
		},
		{
			 name:		"West Africa Summer Time"
			 abbr:		"WAST"
			 UTCOffset:	"GMT+0200"
		},
		{
			 name:		"West Africa Time"
			 abbr:		"WAT"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Western European Daylight Time"
			 abbr:		"WEDT"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Western European Summer Time"
			 abbr:		"WEST"
			 UTCOffset:	"GMT+0100"
		},
		{
			 name:		"Western European Time"
			 abbr:		"WET"
			 UTCOffset:	"GMT+0000"
		},
		{
			 name:		"Western Standard Time"
			 abbr:		"WST"
			 UTCOffset:	"GMT+0800"
		},
		{
			 name:		"Yakutsk Time"
			 abbr:		"YAKT"
			 UTCOffset:	"GMT+0900"
		},
		{
			 name:		"Yekaterinburg Time"
			 abbr:		"YEKT"
			 UTCOffset:	"GMT+0500"
		}
]